Index: .gitignore
===================================================================
--- .gitignore	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ .gitignore	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,24 @@
+# specific source code stuff
+version.c
+.git-version
+
+# eclipse file
+.project
+.cproject
+.settings
+
+# automake stuff
+configure
+config.h*
+*.in
+build*
+aclocal.m4
+autom4te.cache
+
+# testsuite stuff
+testsuite
+*.m4
+
+# miscellaneous stuff
+*.log
+
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -1,4 +1,6 @@
 ACLOCAL_AMFLAGS = -I m4
 SUBDIRS = src src/unittests doc tests 
+
+AUTOMAKE_OPTIONS = subdir-objects
 
 EXTRA_DIST = autogen.sh
@@ -7,2 +9,5 @@
 doc:
 	cd doc && make doxygen-docs
+	
+unity:
+	cd src && make unity
Index: TestRunnerClient.cpp
===================================================================
--- TestRunnerClient.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ TestRunnerClient.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,542 @@
+/*******************************************************************************
+ * Copyright (c) 2008 Gerhard Leonhartsberger.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *******************************************************************************/
+
+#include "TestRunnerClient.h"
+
+#ifdef CPPUNIT_MAIN
+
+#include "cppunit/TestResultCollector.h"
+#include "cppunit/XmlOutputter.h"
+#include "cppunit/TestSuite.h"
+#include "cppunit/TestResult.h"
+#include "cppunit/TestFailure.h"
+#include "cppunit/SourceLine.h"
+#include "cppunit/Exception.h"
+#include "cppunit/extensions/TestFactoryRegistry.h"
+#include "cppunit/extensions/TestDecorator.h"
+#include "cppunit/ui/text/TestRunner.h"
+
+#include <iostream>
+#include <sstream>
+#include <typeinfo>
+#include <vector>
+#include <cstring>
+
+#include <errno.h>
+#include <unistd.h>
+#include <sys/time.h>
+#include <stdlib.h>
+
+
+#ifdef _WIN32 // Bugzilla 40710
+#include <windows.h>
+#include <winbase.h>
+#include <winsock.h>
+#else
+#include <netinet/in.h>
+#include <sys/socket.h>
+#include <arpa/inet.h>
+#include <netdb.h>
+#endif
+
+enum { MAX_HOSTNAME_SIZE=255 };
+
+/*
+ * CppUnitServer protocol constants
+ */
+static const std::string TRACE_START = "%TRACES ";
+static const std::string TRACE_END = "%TRACEE ";
+static const std::string TEST_RUN_START = "%TESTC  ";
+static const std::string TEST_START = "%TESTS  ";
+static const std::string TEST_END = "%TESTE  ";
+static const std::string TEST_ERROR = "%ERROR  ";
+static const std::string TEST_FAILED = "%FAILED ";
+static const std::string TEST_RUN_END = "%RUNTIME";
+static const std::string TEST_STOPPED = "%TSTSTP ";
+static const std::string TEST_TREE = "%TSTTREE";
+
+TestRunnerClient::TestRunnerClient()
+{
+	fTestResult = 0;
+	fClientSocket = -1;
+	fPort = 0;
+	fKeepAlive = 0;
+	fDebugMode = 0;
+
+	fHost = (char *) malloc(MAX_HOSTNAME_SIZE);
+	strcpy(fHost, "");
+}
+
+TestRunnerClient::~TestRunnerClient() {
+
+	if (fHost != NULL) {
+		free(fHost);
+	}
+}
+
+int TestRunnerClient::Run()
+{
+	if (fDebugMode)
+	{
+		std::cerr << "TestRunnerClient: Starting client." << std::endl;
+	}
+
+	if (Connect() == -1) {
+		return -1;
+	}
+
+	InstallListeners();
+
+	RunTests();
+
+	UninstallListeners();
+
+	if(fTestResult != NULL)
+	{
+		fTestResult->stop();
+		fTestResult= NULL;
+	}
+
+	ShutDown();
+
+	return 0;
+}
+
+void TestRunnerClient::Init(int n, char *args[])
+{
+	ParseCommandLine(n, args);
+	DefineHostName();
+}
+
+void TestRunnerClient::ParseCommandLine(int n, char *args[])
+{
+	// parse all arguments passed by args
+	for(int i = 0; i < n; i++)
+	{
+		std::string arg(args[i]);
+
+		// port option
+		std::string portOption("-port=");
+		int pos = arg.find(portOption);
+		if(pos> -1)
+		{
+			std::string v = arg.substr(pos + portOption.length(), arg.length());
+			fPort = atoi(v.c_str());
+		}
+
+		// debug option
+		std::string debugOption("-debug");
+		pos = arg.find(debugOption);
+		if(pos> - 1)
+		{
+			fDebugMode = 1;
+		}
+	}
+}
+
+void TestRunnerClient::DefineHostName()
+{
+	// set fHost to hostname or localhost
+	int ret = gethostname(fHost, MAX_HOSTNAME_SIZE);
+	if (ret == -1)
+	{
+		strcpy(fHost, "localhost");
+	}
+}
+
+int TestRunnerClient::Connect()
+{
+
+#ifdef _WIN32 // Bugzilla 40710
+	if (fDebugMode)
+	{
+		std::cerr << "TestRunnerClient: Starting Windows Sockets WSAStartup()." << std:endl;
+	}
+
+	// start up Windows Sockets
+	WSADATA WSAData;
+	int result = WSAStartup (MAKEWORD(1, 1), &WSAData);
+	if (result != NO_ERROR)
+	{
+		std::cerr << "TestRunnerClient: WSAStartup() failed! Error code: " << result << std::endl;
+		return -1;
+	}
+#endif
+
+	if (fDebugMode)
+	{
+		std::cerr << "TestRunnerClient: Trying to connect to " << fHost << ":" << fPort << std::endl;
+	}
+
+	fClientSocket = socket(AF_INET, SOCK_STREAM, 0);
+	if (fClientSocket == -1)
+	{
+		std::cerr << "TestRunnerClient: Socket creation failed! error code: " << fClientSocket << std::endl;
+		return -1;
+	}
+
+	struct hostent *host = gethostbyname(fHost);
+	if (host == NULL)
+	{
+		std::cerr << "TestRunnerClient: Cannot find host address for " << fHost << "." << std::endl;
+		fClientSocket = -1;
+		return -1;
+	}
+
+	struct sockaddr_in name;
+	memset((void *)&name, 0, sizeof(struct sockaddr_in));
+	name.sin_family = AF_INET;
+	name.sin_port = htons(fPort);
+
+	memcpy(&name.sin_addr, host->h_addr, host->h_length);
+
+	if (fDebugMode) {
+		std::cerr << "TestRunnerClient: Waiting for the JVM to listen ... (trying 3 times)" << std::endl;
+	}
+
+	int ret = -1;
+	int j = 0;
+	while ((j < 3) && (ret == -1))
+	{
+		ret = ::connect(fClientSocket, (struct sockaddr *) &name, sizeof(struct sockaddr_in));
+		if (ret == -1)
+		{
+			if (fDebugMode) {
+				std::cerr << "TestRunnerClient: Connection request, waiting 1 second. "
+				<< ((j-3)*-1) << " times left." << std::endl;
+			}
+			PrivateSleep(1000);
+			j++;
+		}
+	}
+	if (ret == -1)
+	{
+		std::cerr << "TestRunnerClient: No connection established. Error code: " << errno << std::endl;
+		fClientSocket = -1;
+		return -1;
+	}
+
+	if (fDebugMode) {
+		std::cerr << "TestRunnerClient: Connection established." << std::endl;
+	}
+	return 0;
+}
+
+void TestRunnerClient::InstallListeners()
+{
+	fTestResult = new CppUnit::TestResult();
+	fTestResult->addListener(this);
+}
+
+void TestRunnerClient::UninstallListeners()
+{
+	fTestResult->removeListener(this);
+}
+
+void TestRunnerClient::RunTests()
+{
+
+	CppUnit::TestFactoryRegistry &registry = CppUnit::TestFactoryRegistry::getRegistry();
+	CppUnit::Test *suite = registry.makeTest();
+	int count = suite->countTestCases();
+	NotifyTestRunStarted(count);
+
+	if (count == 0)
+	{
+		NotifyTestRunEnded(0);
+	}
+
+	long startTime = CurrentTimeMillis();
+	if (fDebugMode)
+	{
+		std::cerr <<"TestRunnerClient: Start sending test case tree ..." << std::endl;
+	}
+
+	SendTestTree(suite);
+
+	int elapsedTime = CurrentTimeMillis() - startTime;
+	if (fDebugMode) {
+		std::cerr << "TestRunnerClient: Done sending test case tree. Elapsed time is "
+		<< elapsedTime << "ms." << std::endl;
+	}
+
+	long testStartTime = CurrentTimeMillis();
+	if (fDebugMode) {
+		std::cerr << "TestRunnerClient: Test start time is " << testStartTime
+		<< "ms." << std::endl;
+	}
+
+	suite->run(fTestResult);
+
+	if (fTestResult == NULL || fTestResult->shouldStop())
+	{
+		NotifyTestRunStopped(CurrentTimeMillis() - testStartTime);
+	}
+	else
+	{
+		NotifyTestRunEnded(CurrentTimeMillis() - testStartTime);
+	}
+}
+
+void TestRunnerClient::ShutDown()
+{
+	if (fClientSocket != -1)
+	{
+		if (fDebugMode) {
+			std::cerr << "TestRunnerClient: Closing connection to CppUnit sever at "
+			<< fHost << ":" << fPort << std::endl;
+		}
+
+#ifdef _WIN32 // Bugzilla 40710
+		// TODO: std:err output for error return codes
+		closesocket(fClientSocket);
+		WSACleanup();
+#else
+		int result = close(fClientSocket);
+		if (result != 0)
+		{
+			std::cerr << "TestRunnerClient: Close connection error: " << errno << std::endl;
+		}
+#endif
+
+		fClientSocket = -1;
+	}
+}
+
+void TestRunnerClient::Stop()
+{
+	if (fTestResult != NULL)
+	{
+		fTestResult->stop();
+	}
+}
+
+void TestRunnerClient::SendTestTree(CppUnit::Test *test)
+{
+	if (typeid(*test) == typeid(CppUnit::TestDecorator))
+	{
+		class TmpClass : public CppUnit::TestDecorator {
+
+		public:
+			TmpClass(Test *t):CppUnit::TestDecorator(t)
+			{
+				// nothing to do
+			}
+
+			~TmpClass() // Bugzilla 39894
+			{
+				// nothing to do
+			}
+
+			CppUnit::Test *getTest()
+			{
+				return m_test;
+			}
+		};
+
+		TmpClass *t = (TmpClass *)test;
+		SendTestTree(t->getTest());
+	}
+	else if (typeid(*test) == typeid(CppUnit::TestSuite))
+	{
+		CppUnit::TestSuite *suite = (CppUnit::TestSuite *)test;
+		const std::vector<CppUnit::Test *> &x = suite->getTests();
+
+		std::ostringstream os;
+		os << suite->getName() << ",true," << x.size();
+		NotifyTestTreeEntry(os.str());
+
+		for(unsigned int i=0; i < x.size(); i++)
+		{
+			SendTestTree(x[i]);
+		}
+	}
+	else
+	{
+		std::ostringstream os;
+		os << test->getName() << ",false," << test->countTestCases();
+		NotifyTestTreeEntry(os.str());
+	}
+}
+
+void TestRunnerClient::SendMessage(std::string msg)
+{
+	if (fClientSocket == -1)
+	{
+		return;
+	}
+
+#ifdef _WIN32 // Bugzilla 40710
+	send (fClientSocket, msg.c_str(), msg.length(), 0);
+	send (fClientSocket, "\n", 1, 0);
+#else
+	write(fClientSocket, msg.c_str(), msg.length());
+	write(fClientSocket, "\n", 1);
+#endif
+
+	if (fDebugMode)
+	{
+		std::cerr << "TestRunnerClient: Sent message \"" << msg << "\""
+		<< std::endl;
+	}
+}
+
+void TestRunnerClient::NotifyTestRunStarted(int testCount)
+{
+	std::ostringstream os;
+	os << TEST_RUN_START << testCount;
+	SendMessage(os.str());
+}
+
+void TestRunnerClient::NotifyTestRunEnded(long elapsedTime)
+{
+	std::ostringstream os;
+	os << TEST_RUN_END << elapsedTime;
+	SendMessage(os.str());
+}
+
+void TestRunnerClient::NotifyTestRunStopped(long elapsedTime)
+{
+	std::ostringstream os;
+	os << TEST_STOPPED << elapsedTime;
+	SendMessage(os.str());
+}
+
+void TestRunnerClient::NotifyTestTreeEntry(std::string treeEntry)
+{
+	SendMessage(TEST_TREE + treeEntry);
+}
+
+void TestRunnerClient::NotifyTestStarted(std::string testName)
+{
+	SendMessage(TEST_START + testName);
+}
+
+void TestRunnerClient::NotifyTestEnded(std::string testName)
+{
+	SendMessage(TEST_END + testName);
+}
+
+void TestRunnerClient::NotifyTestFailed(std::string status, std::string testName, std::string trace)
+{
+	SendMessage(status + testName);
+	SendMessage(TRACE_START);
+	SendMessage(trace);
+	SendMessage(TRACE_END);
+}
+
+// From TestListener
+void TestRunnerClient::startTest(CppUnit::Test *test)
+{
+	NotifyTestStarted(test->getName());
+}
+
+// From TestListener
+void TestRunnerClient::addFailure(const CppUnit::TestFailure &failure)
+{
+	if(failure.isError())
+	{
+		NotifyTestFailed(TEST_ERROR,failure.failedTestName(),GetTrace(failure));
+	}
+	else
+	{
+		NotifyTestFailed(TEST_FAILED,failure.failedTestName(),GetTrace(failure));
+	}
+}
+
+// From TestListener
+void TestRunnerClient::endTest(CppUnit::Test *test)
+{
+	NotifyTestEnded(test->getName());
+}
+
+std::string TestRunnerClient::GetTrace(const CppUnit::TestFailure &failure)
+{
+	std::ostringstream os;
+
+	CppUnit::Exception *e=failure.thrownException();
+	if(e->sourceLine().lineNumber()!=-1)
+	{
+		os << "File " << e->sourceLine().fileName() << ":" << e->sourceLine().lineNumber() << "\n";
+	}
+	else
+	{
+		os << "File Unknown:1\n";
+	}
+	/* TODO: expected, actual value implementation
+	 if(typeid(*e)==typeid(CppUnit::NotEqualException))
+	 {
+	 CppUnit::NotEqualException *ne=(CppUnit::NotEqualException *)e;
+
+	 os << "Expected Value: " << ne->expectedValue() << "\n";
+	 os << "Actual Value: " << ne->expectedValue() << "\n";
+	 os << "Additional Message: " << ne->additionalMessage() << "\n";
+	 }
+	 else
+	 {
+	 End		*/
+	os << "Message: " << std::string(e->what()) << "\n";
+	/*		} */
+
+	return(os.str());
+}
+
+long TestRunnerClient::CurrentTimeMillis()
+{
+#ifdef _WIN32 // Bugzilla 40710
+	unsigned long long p;
+	__asm__ __volatile__ ("rdtsc" : "=A" (p));
+	return (unsigned long)p;
+#else
+	struct timeval tv;
+	gettimeofday(&tv, NULL);
+
+	return((long)(tv.tv_sec*1000) + (tv.tv_usec/1000));
+#endif
+}
+
+void TestRunnerClient::PrivateSleep(int millisecs)
+{
+	struct timeval delta;
+	delta.tv_sec = (millisecs * 1000L) / 1000000L;
+	delta.tv_usec = (millisecs * 1000L) % 1000000L;
+	select (0, NULL, NULL, NULL, &delta);
+}
+
+/*!
+ * This is the main routine. The TestRunnerClient is initialized and run. The
+ * CppUnit tests are created, executed, and sent to the CppUnitServer.
+ * If no connection to the CppUnitServer was established the CppUnit tests are
+ * displayed on the console.
+ *
+ * @return <code>0</code> if the results of the CppUnit tests were sent to the
+ *         CppUnitServer successfully.
+ *         <code>-1</code> if a connection could not be established to the
+ *         CppUnitServer.
+ */
+int CPPUNIT_MAIN(int n, char *arg[])
+{
+	TestRunnerClient client;
+
+	client.Init(n, arg);
+	int ret = client.Run();
+	if (ret == -1)
+	{
+		CppUnit::TestFactoryRegistry &registry = CppUnit::TestFactoryRegistry::getRegistry();
+		CppUnit::Test *suite = registry.makeTest();
+
+		CppUnit::TextUi::TestRunner *runner = NULL;
+		runner = new CppUnit::TextUi::TestRunner();
+		runner->addTest(suite);
+		runner->run();
+	}
+
+	exit(ret);
+}
+
+#endif /*CPPUNIT_MAIN*/
Index: TestRunnerClient.h
===================================================================
--- TestRunnerClient.h	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ TestRunnerClient.h	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,140 @@
+/*******************************************************************************
+ * Copyright (c) 2008 Gerhard Leonhartsberger.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *******************************************************************************/
+
+#ifndef TESTRUNNERSERVER_H_
+#define TESTRUNNERSERVER_H_
+
+#ifdef CPPUNIT_MAIN
+
+#include "cppunit/TestListener.h"
+
+#include <vector>
+#include <string>
+
+/*!
+ * Class <code>TestRunnerClient</code> handles the network connection to the
+ * <code>CppUnitServer</code> and executes all registered CppUnit tests.
+ * <p>
+ * The meta data of the CppUnit tests and the test results are sent to the
+ * <code>CppUnitServer</code> for displaying.
+ * </p>
+ * <p>
+ * For debugging purposes class <code>TestRunnerClient</code> displays debug
+ * messages on <code>std.cerr</code>. The debug modus is activated by specifying
+ * <code>debug</code> command line option. The command line is parsed by method
+ * <code>Init()</code>.
+ * </p>
+ * <p>
+ * Note: This class is not intended to be subclassed by clients. This class is
+ * based on the original <code>RemoteTestRunner</code> class provided by
+ * <code>org.eclipse.cdt.cppunit</code>.
+ * </p>
+ *
+ * @author Gerhard Leonhartsberger
+ */
+class TestRunnerClient: public CppUnit::TestListener
+{
+private:
+	CppUnit::TestResult *fTestResult;
+	int fClientSocket;
+	char *fHost;
+	int fPort;
+	int fDebugMode;
+	int fKeepAlive;
+
+public:
+	TestRunnerClient();
+	virtual ~TestRunnerClient();
+
+	/*!
+	 * Initializes the <code>TestRunnerClient</code>.
+	 * <p>
+	 * The given <code>args</code> are parsed. The syntax for the arguments is
+	 * defined in EBNF as follows: <code>{-option=value}</code>
+	 * </p>
+	 *
+	 * @param n The number of arguments.
+	 * @param args The argument values. Valid options are:
+	 * 			   <li><code>-debug</code> When present the TestRunnerClient
+	 * 				is run in debug modus and displays debug messages.</li>
+	 * 			   <li><code>-port=number</code> Defines the port where
+	 * 			   CppUnitServer is listening for client connections.</li>
+	 */
+	void Init(int n,char *args[]);
+
+	/*!
+	 * Runs the TestRunnerClient. A trial to connect to the CppUnitServer is done.
+	 * The test results are sent to the CppUnitServer.
+	 *
+	 * @return The return value is <code>0</code> when the CppUnitServer was connected successfully
+	 * otherwise the return value is <code>-1</code>.
+	 */
+	int Run();
+
+	/*!
+	 * Stops processing <code>CppUnit</code> from executing tests.
+	 */
+	void Stop();
+
+	/*!
+	 * Method defined in <code>CppUnit::TestListener</code>.
+	 */
+	void startTest(CppUnit::Test *test);
+
+	/*!
+	 * Method defined in <code>CppUnit::TestListener</code>.
+	 */
+	void addFailure(const CppUnit::TestFailure &failure);
+
+	/*!
+	 * Method defined in <code>CppUnit::TestListener</code>.
+	 */
+	void endTest(CppUnit::Test *test);
+
+private:
+	int Connect();
+	void RunTests();
+	void ShutDown();
+
+	// utility methods
+	void ParseCommandLine(int n, char *args[]);
+	void DefineHostName();
+	void InstallListeners();
+	void UninstallListeners();
+
+	/*!
+	 * Sends the given test to the CppUnitView.
+	 * <p>
+	 * In case of test is of type CppUnit::Test the following protocol is sent:
+	 * <code>TSTTREE name, false, testCaseCount</code>
+	 * </p>
+	 * <p>
+	 * In case of test is of type CppUnit::TestSuite the following protocol is sent:
+	 * TSTTREE name, true, testCount
+	 * </p>
+	 * @param test the CppUnit test
+	 */
+	void SendTestTree(CppUnit::Test *test);
+	void SendMessage(std::string msg);
+
+	// Notification methods
+	void NotifyTestRunStarted(int testCount);
+	void NotifyTestRunEnded(long elapsedTime);
+	void NotifyTestRunStopped(long elapsedTime);
+	void NotifyTestTreeEntry(std::string treeEntry);
+	void NotifyTestStarted(std::string testName);
+	void NotifyTestEnded(std::string testName);
+	void NotifyTestFailed(std::string status, std::string testName, std::string trace);
+
+	std::string GetTrace(const CppUnit::TestFailure &failure);
+	long CurrentTimeMillis();
+	void PrivateSleep(int millisecs);
+};
+
+#endif /*CPPUNIT_MAIN*/
+#endif /*TESTRUNNERSERVER_H_*/
Index: configure.ac
===================================================================
--- configure.ac	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ configure.ac	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,8 @@
 AC_CONFIG_AUX_DIR(config)
 AC_CONFIG_SRCDIR([src/builder.cpp])
-AC_CONFIG_HEADER([config.h])
+AC_CONFIG_HEADER([config.h libmolecuilder_config.h])
+AC_CONFIG_MACRO_DIR([m4])
 
-AM_INIT_AUTOMAKE(dist-bzip2)
+AM_INIT_AUTOMAKE(dist-bzip2 parallel-tests)
 
 # Checks for programs.
@@ -14,5 +15,6 @@
 AC_PROG_CXX
 AC_PROG_CC
-AC_PROG_RANLIB
+# obselete by LT_INIT
+#AC_PROG_RANLIB
 AC_PROG_INSTALL
 AC_CHECK_PROG([LATEX],[latex],[latex],[:])
@@ -23,6 +25,15 @@
 AM_MISSING_PROG([DOXYGEN], [doxygen])
 
+LT_INIT([disable-static])
+
+# Define these substitions here to keep all version information in one place.
+# For information on how to properly maintain the library version information,
+# refer to the libtool manual, section "Updating library version information":
+# http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
+AC_SUBST([MOLECUILDER_SO_VERSION], [1:2:0])
+AC_SUBST([MOLECUILDER_API_VERSION], [1.0])
+
 # Checks for libraries.
-AC_CHECK_LIB(m, sqrt, ,AC_MSG_ERROR([compatible libc math library not found]))
+AC_CHECK_LIB(m, sqrt, , AC_MSG_ERROR([compatible libc math library not found]))
 
 # Boost libraries
@@ -110,8 +121,14 @@
 	doc/molecuilder.xml])
 AC_CONFIG_FILES([
+  molecuilder-${MOLECUILDER_API_VERSION}.pc:molecuilder.pc.in])
+AC_CONFIG_FILES([
 	Makefile 
 	doc/Makefile 
 	src/Makefile 
 	src/Actions/Makefile
+  src/Exceptions/Makefile
+  src/Helpers/Makefile
+  src/LinearAlgebra/Makefile
+  src/Parser/Makefile
 	src/UIElements/Makefile
 	src/unittests/Makefile])
Index: m4/gwqt4.m4
===================================================================
--- m4/gwqt4.m4	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ m4/gwqt4.m4	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -147,5 +147,5 @@
         QT_LIBS="$QT_LIB"
         if test $QT_IS_STATIC = yes ; then
-            QT_LIBS="$QT_LIBS -L$x_libraries -lXext -lX11 -lm -lSM -lICE"
+            QT_LIBS="$QT_LIBS -lXext -lX11 -lm -lSM -lICE"
         fi
         ;;
@@ -154,5 +154,5 @@
         QT_LIBS="$QT_LIB"
         if test $QT_IS_STATIC = yes ; then
-            QT_LIBS="$QT_LIBS -L$x_libraries -lXext -lX11 -lm -lSM -lICE -ldl"
+            QT_LIBS="$QT_LIBS -lXext -lX11 -lm -lSM -lICE -ldl"
         fi
         ;;
@@ -162,5 +162,5 @@
         QT_LIBS="$QT_LIB"
         if test $QT_IS_STATIC = yes ; then
-            QT_LIBS="$QT_LIBS -L$x_libraries -lXext -lX11 -lm -lSM -lICE"
+            QT_LIBS="$QT_LIBS -lXext -lX11 -lm -lSM -lICE"
         fi
         ;;
@@ -169,5 +169,5 @@
         QT_LIBS="$QT_LIB"
         if test $QT_IS_STATIC = yes ; then
-            QT_LIBS="$QT_LIBS -L$x_libraries -lXext -lX11 -lm -lSM -lICE -lresolv -lsocket -lnsl"
+            QT_LIBS="$QT_LIBS -lXext -lX11 -lm -lSM -lICE -lresolv -lsocket -lnsl"
         fi
         ;;
Index: molecuilder.pc.in
===================================================================
--- molecuilder.pc.in	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ molecuilder.pc.in	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,11 @@
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
+
+Name: @PACKAGE_NAME@
+Description: MoleCuilder - a molecular builder
+Version: @PACKAGE_VERSION@
+URL: @PACKAGE_URL@
+Libs: -L${libdir} -lMolecuilderActions-@EXAMPLE_API_VERSION@ -lMolecuilderParser-@EXAMPLE_API_VERSION@
+Cflags: -I${includedir}/molecuilder-@EXAMPLE_API_VERSION@ -I${libdir}/molecuilder-@EXAMPLE_API_VERSION@/include
Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/Action.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -13,5 +18,11 @@
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/ActionHistory.hpp"
+#include "Exceptions/MissingValueException.hpp"
+#include "UIElements/Dialog.hpp"
 #include "Helpers/MemDebug.hpp"
+#include "UIElements/UIFactory.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 using namespace std;
@@ -29,5 +40,5 @@
 {
   if(_doRegister){
-    ActionRegistry::getInstance().registerAction(this);
+    ActionRegistry::getInstance().registerInstance(this);
   }
 }
@@ -40,10 +51,28 @@
 }
 
-void Action::call(){
+Dialog * Action::createDialog(){
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  return fillDialog(dialog);
+}
+
+void Action::call(enum QueryOptions flag){
   if(!isActive()){
     return;
   }
   // forward to private virtual
-  state_ptr state = performCall();
+  if (flag == Interactive) {
+    Dialog* dialog = createDialog();
+    if (dialog->hasQueries()) {
+      dialog->display();
+    }
+    delete(dialog);
+  }
+  state_ptr state = Action::failure;
+//  try {
+    state = performCall();
+//  } catch(MissingValueException&) {
+//    DoeLog(0) && (eLog() << Verbose(0) << "There is a value missing for action " << getName() << endl);
+//  };
+
   if(shouldUndo() && state != failure){
     if(canUndo()){
Index: src/Actions/Action.hpp
===================================================================
--- src/Actions/Action.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/Action.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -16,4 +16,5 @@
 class ActionState;
 class ActionSequence;
+class Dialog;
 
 /**
@@ -44,4 +45,14 @@
  * hasRedo() method respectively.
  *
+ * Note that an Action always has two functions createDialog() and performCall(). The former
+ * returns a Dialog filled with query...() functions for all information that we need from the
+ * user. The latter must not contain any interaction but just uses these values (which are
+ * temporarily stored by class ValueStorage) to perform the Action.
+ *
+ * Furthermore, there is a global action function that makes the action callable with already
+ * present parameters (i.e. without user interaction and for internal use within the code only).
+ * This function is basically just a macro, that puts the parameters into the ValueStorage and
+ * calls Action::call(Action::NonInteractive).
+ *
  * Actions can be set to be active or inactive. If an action is set to inactive it is signaling, that
  * some condition necessary for this action to be executed is not currently met. For example the
@@ -78,6 +89,10 @@
  * Building actions is fairly easy. Simply derive from the abstract Action base class and implement
  * the virtual methods. The main code that needs to be executed upon call() should be implemented in
- * the performCall() method. You should also indicate whether the action supports undo by implementing
+ * the performCall() method. Any user interaction should be placed into the dialog returned by
+ * createDialog(). You should also indicate whether the action supports undo by implementing
  * the shouldUndo() and canUndo() methods to return the appropriate flags.
+ *
+ * Also, create the global function to allow for easy calling of your function internally (i.e.
+ * without user interaction). It should have the name of the Action class without the suffix Action.
  *
  * The constructor of your derived class also needs to call the Base constructor, passing it the
@@ -122,5 +137,6 @@
  *  <li/> derive YourAction from Action
  *  <li/> pass name and flag for registry to the base constructor
- *  <li/> implement performCall(), performUndo(), performRedo()
+ *  <li/> implement createDialog(), performCall(), performUndo(), performRedo()
+ *  <li/> implement the global function call/macro.
  *  <li/> implement the functions that return the flags for the undo mechanism
  *  <li/> Derive YourActionState from ActionState as necessary
@@ -130,6 +146,15 @@
  *
  * <ul>
+ *  <li/> createDialog():
+ *  <ul>
+ *   <li/> Call makeDialog() from the UIFactory.
+ *   <li/> Call any needed Dialog->Query...() for the values you need with specific keywords.
+ *   <li/> if the action needs to save a state return a custom state object
+ *   <li/> otherwise return Action::success
+ *  </ul>
  *  <li/> performCall():
  *  <ul>
+ *   <li/> obtain parameters you need by ValueStorage::getCurrentValue, matching
+ *         key words from createDialog().
  *   <li/> do whatever is needed to make the action work
  *   <li/> if the action was abborted return Action::failure
@@ -256,4 +281,6 @@
 public:
 
+  enum QueryOptions {Interactive, NonInteractive};
+
   /**
    * This type is used to store pointers to ActionStates while allowing multiple ownership
@@ -278,6 +305,11 @@
    * If the call needs to undone you have to use the History, to avoid destroying
    * invariants used by the History.
-   */
-  void call();
+   *
+   * Note that this call can be Interactive (i.e. a dialog will ask the user for
+   * necessary information) and NonInteractive (i.e. the information will have to
+   * be present already within the ValueStorage class or else a MissingArgumentException
+   * is thrown)
+   */
+  void call(enum QueryOptions state = Interactive);
 
   /**
@@ -337,7 +369,16 @@
   static state_ptr failure;
 
+  /**
+   * This creates the dialog requesting the information needed for this action from the user
+   * via means of the user interface.
+   */
+  Dialog * createDialog();
+
 private:
-  /**
-   * This is called internally when the call is being done. Implement this method to do the actuall
+
+  virtual Dialog * fillDialog(Dialog*)=0;
+
+  /**
+   * This is called internally when the call is being done. Implement this method to do the actual
    * work of the Action. Implement this in your Derived classes. Needs to return a state that can be
    * used to undo the action.
Index: src/Actions/ActionHistory.cpp
===================================================================
--- src/Actions/ActionHistory.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionHistory.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -67,6 +72,9 @@
 
 /****************** Contained actions *******************/
+
+const char ActionHistory::UndoAction::NAME[] = "undo";
+
 ActionHistory::UndoAction::UndoAction(ActionHistory *_hist) :
-  Action("Undo"),
+  Action(NAME),
   hist(_hist)
 {}
@@ -86,5 +94,11 @@
 }
 
+Dialog* ActionHistory::UndoAction::fillDialog(Dialog *dialog){
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
+}
+
 Action::state_ptr ActionHistory::UndoAction::performCall(){
+  std::cout << "Undo" << std::endl;
   hist->undoLast();
   return Action::success;
@@ -101,6 +115,8 @@
 }
 
+const char ActionHistory::RedoAction::NAME[] = "redo";
+
 ActionHistory::RedoAction::RedoAction(ActionHistory *_hist) :
-    Action("Redo"),
+    Action(NAME),
     hist(_hist)
 {}
@@ -117,5 +133,11 @@
 
 bool ActionHistory::RedoAction::isActive(){
+  std::cout << "Redo" << std::endl;
   return hist->hasRedo();
+}
+
+Dialog* ActionHistory::RedoAction::fillDialog(Dialog *dialog){
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
 }
 
Index: src/Actions/ActionHistory.hpp
===================================================================
--- src/Actions/ActionHistory.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ActionHistory.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -38,5 +38,6 @@
 
     virtual bool isActive();
-
+  protected:
+    virtual Dialog * fillDialog(Dialog *dialog);
   private:
     virtual Action::state_ptr performCall();
@@ -45,4 +46,6 @@
 
     ActionHistory *hist;
+
+    static const char NAME[];
   };
 
@@ -57,4 +60,6 @@
     virtual bool isActive();
 
+  protected:
+    virtual Dialog * fillDialog(Dialog *dialog);
   private:
     virtual Action::state_ptr performCall();
@@ -63,4 +68,6 @@
 
     ActionHistory *hist;
+
+    static const char NAME[];
   };
 
